HDU3466~Proud Merchants(01背包+贪心)

来源:互联网 发布:网络神剧排行榜2016 编辑:程序博客网 时间:2024/06/05 11:38

Proud Merchants

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)
Total Submission(s): 6176    Accepted Submission(s): 2554


Problem Description
Recently, iSea went to an ancient country. For such a long time, it was the most wealthy and powerful kingdom in the world. As a result, the people in this country are still very proud even if their nation hasn’t been so wealthy any more.
The merchants were the most typical, each of them only sold exactly one item, the price was Pi, but they would refuse to make a trade with you if your money were less than Qi, and iSea evaluated every item a value Vi.
If he had M units of money, what’s the maximum value iSea could get?

 

Input
There are several test cases in the input.

Each test case begin with two integers N, M (1 ≤ N ≤ 500, 1 ≤ M ≤ 5000), indicating the items’ number and the initial money.
Then N lines follow, each line contains three numbers Pi, Qi and Vi (1 ≤ Pi ≤ Qi ≤ 100, 1 ≤ Vi ≤ 1000), their meaning is in the description.

The input terminates by end of file marker.

 

Output
For each test case, output one integer, indicating maximum value iSea could get.

 

Sample Input
2 1010 15 105 10 53 105 10 53 5 62 7 3
 

Sample Output
511
 

Author
iSea @ WHU
 

Source
2010 ACM-ICPC Multi-University Training Contest(3)——Host by WHU
 

Recommend
zhouzeyong

一看就想到了01背包,但怎么也写不对,看别人的代码p-q排了一下序,A了,不明白为什么这样排序,今天看大佬的题解终于明白了,大佬不愧是大佬;
首先看这两组数据
A 5 10 5
B 3 5 6
 直接买A或直接买B都可以买,先买A再买B,需要pa+qb=5+5,先买B再买A,需要pb+qa=3+10;
假设有物品X和Y,先买X在买Y的价格较小,则有px+qy<py+qx,转换一下可得qx-px>qy-py;,所以先买qx-px较大的物品;
这里强调一下排序,因为01背包是for(j=m;j>q[i];j--),所以排在后面的物品会先买,故从小到大排序;
大佬传送门http://blog.csdn.net/blesslzh0108/article/details/65627729
#include <iostream>#include <iomanip>#include<stdio.h>#include<string.h>#include<stack>#include<stdlib.h>#include<queue>#include<map>#include<math.h>#include<algorithm>#include<vector>#define M 5005#define LL long long int#define mem(a,b) memset(a,b,sizeof(a))using namespace std;struct node{    int p,q,v;}e[M];int f[M];int n,m;int cmp(node a,node b){    return a.q-a.p<b.q-b.p;}int main(){    while(~scanf("%d%d",&n,&m))    {        mem(f,0);        for(int i=1;i<=n;i++)        {            scanf("%d%d%d",&e[i].p,&e[i].q,&e[i].v);        }        sort(e+1,e+1+n,cmp);        for(int i=1;i<=n;i++)        {            for(int j=m;j>=e[i].q;j--)            {                f[j]=max(f[j],f[j-e[i].p]+e[i].v);            }        }        printf("%d\n",f[m]);    }}


0 0
原创粉丝点击